/* avq.h -- support header for tlearn-AVQ
 *
 * Author: Dylan Muir (dr.muir@syudent.qut.edu.au)
 *         QUT MLRC LPG Semester 2 1999
 * Date: 18th October, 1999
 * Modified:
 * Version: 0.01
 *
 */

#ifndef	_avq_h
#define	_avq_h

#include "vector_utils.h"
#include "cluster.h"

/* -- Codebook typedef */

typedef	vector **codebook;


/* -- Codebook functions -- */

codebook CodebookNew(int slots);
codebook CodebookDestroy(codebook book, int slots);  
codebook CodebookNewFromCluster(cluster *clust);
codebook CodebookMakeCopy(codebook book, int slots);
void WriteCodebook(FILE *output, codebook book, int slots);


/* -- AVQ functions -- */

int FindNearestNeighbour(vector *vect, codebook currentBook, int numSeeds);


#endif	/* _avq_h */

/* --- END of avq.h --- */


