/* avq_subs.h -- SUbroutines for AVQ
 */

#ifndef	_avq_subs_h
#define	_avq_subs_h

#include <stdio.h>
#include "stddefs.h"
#include "vector_utils.h"
#include "cluster.h"

typedef	vector	**codebook;

bool Allocate2DArray(char ***array, int xSize, int ySize, size_t elementSize);
bool CheckClusterDimensions(cluster *clust);
codebook ReadTrainingSet(FILE *vectorFile, int *numVectors);
cluster **MakeClusters(int numClusters);
cluster **DestroyClusters(cluster **clusters, int numClusters);
int FindNearestNeighbour(vector *vect, codebook currentBook, int numClusters);
int FindNearestOtherCluster(codebook currentBook, int numClusters, int target);
double GetError(cluster **clusters, codebook book, int numClusters);
double ClusterRMSDistance(cluster *clust, vector *vect);
codebook InitialiseCodebook(int numClusters, codebook vectorSet, int numSlots);
double CodebookAverageDistance(vector *vect, codebook book, int numClusters);
vector *CodebookCentroid(codebook book, int numSlots);
int FreeCluster(codebook book, int numSlots);
cluster *ClusterFromCodebook(codebook book, int numSlots);


/* -- Codebook functions -- */
codebook CodebookNew(int slots);
codebook CodebookDestroy(codebook book, int slots);
codebook CodebookNewFromCluster(cluster *clust, int *slots);
codebook CodebookMakeCopy(codebook book, int slots);
void WriteCodebook(FILE *output, codebook book, int slots);


#endif /* _avq_subs_h */
